Coin: SoMultiTextureMatrixElement Class Reference

| Coin3D is Free Software, published under the BSD 3-clause license. | https://coin3d.github.io https://www.kongsberg.com/en/kogt/

SoMultiTextureMatrixElement Class Reference
Element Classes

The SoMultiTextureMatrixElement class is used to manage the texture matrix stack for texture units > 0. More...

`#include <Inventor/elements/SoMultiTextureMatrixElement.h>`

Inheritance diagram for SoMultiTextureMatrixElement:

## Classes
class | UnitData

## Public Member Functions
virtual void | init (SoState *state)
virtual void | push (SoState *state)
Public Member Functions inherited from SoAccumulatedElement
virtual SbBool | matches (const SoElement *element) const
Public Member Functions inherited from SoElement
const SoType | getTypeId (void) const
int | getStackIndex (void) const
virtual void | pop (SoState *state, const SoElement *prevTopElement)
void | setDepth (const int depth)
int | getDepth (void) const
virtual void | print (FILE *file=stdout) const
virtual | ~SoElement ()

## Static Public Member Functions
static SoType | getClassTypeId (void)
static int | getClassStackIndex (void)
static void * | createInstance (void)
static void | initClass (void)
static void | set (SoState *const state, SoNode *const node, const int unit, const SbMatrix &matrix)
static void | mult (SoState *const state, SoNode *const node, const int unit, const SbMatrix &matrix)
static const SbMatrix & | get (SoState *const state, const int unit=0)
static void | makeIdentity (SoState *const state, SoNode *const node, const int unit=0)
static void | set (SoState *const state, SoNode *const node, const SbMatrix &matrix)
static void | mult (SoState *const state, SoNode *const node, const SbMatrix &matrix)
static void | translateBy (SoState *const state, SoNode *const node, const SbVec3f &translation)
static void | rotateBy (SoState *const state, SoNode *const node, const SbRotation &rotation)
static void | scaleBy (SoState *const state, SoNode *const node, const SbVec3f &scaleFactor)
Static Public Member Functions inherited from SoAccumulatedElement
static SoType | getClassTypeId (void)
static int | getClassStackIndex (void)
static void | initClass (void)
Static Public Member Functions inherited from SoElement
static void | initClass (void)
static SoType | getClassTypeId (void)
static int | getClassStackIndex (void)
static void | initElements (void)
static int | getNumStackIndices (void)
static SoType | getIdFromStackIndex (const int stackIndex)

## Protected Member Functions
| SoMultiTextureMatrixElement (void)
virtual | ~SoMultiTextureMatrixElement ()
int | getNumUnits () const
UnitData & | getUnitData (const int unit)
const UnitData & | getUnitData (const int unit) const
virtual void | multElt (const int unit, const SbMatrix &matrix)
virtual void | setElt (const int unit, const SbMatrix &matrix)
virtual const SbMatrix & | getElt (const int unit) const
Protected Member Functions inherited from SoAccumulatedElement
virtual | ~SoAccumulatedElement ()
void | clearNodeIds (void)
void | addNodeId (const SoNode *const node)
void | setNodeId (const SoNode *const node)
void | copyNodeIds (const SoAccumulatedElement *copyfrom)
virtual SoElement * | copyMatchInfo (void) const
virtual void | captureThis (SoState *state) const
Protected Member Functions inherited from SoElement
| SoElement (void)
void | capture (SoState *const state) const
void | setTypeId (const SoType typeId)
void | setStackIndex (const int index)
SoElement * | getNextInStack (void) const
SoElement * | getNextFree (void) const

## Additional Inherited Members
Static Protected Member Functions inherited from SoElement
static SoElement * | getElement (SoState *const state, const int stackIndex)
static const SoElement * | getConstElement (SoState *const state, const int stackIndex)
static int | createStackIndex (const SoType id)
Protected Attributes inherited from SoAccumulatedElement
SbList< SbUniqueId > | nodeIds
Protected Attributes inherited from SoElement
SoType | typeId
int | stackIndex
int | depth
Static Protected Attributes inherited from SoElement
static int | classStackIndex
static SoTypeList * | stackToType

## Detailed Description

The SoMultiTextureMatrixElement class is used to manage the texture matrix stack for texture units > 0.

The texture matrix is used to transform texture coordinates before being used to map textures onto polygons.

Since
  Coin 2.2

## Constructor & Destructor Documentation

## ◆ SoMultiTextureMatrixElement()

SoMultiTextureMatrixElement::SoMultiTextureMatrixElement | ( | void |  | ) |
| protected

Constructor.

## ◆ ~SoMultiTextureMatrixElement()

SoMultiTextureMatrixElement::~SoMultiTextureMatrixElement | ( | void |  | ) |
| protectedvirtual

Destructor.

## Member Function Documentation

## ◆ getClassTypeId()

SoType SoMultiTextureMatrixElement::getClassTypeId | ( | void |  | ) |
| static

This static method returns the SoType object associated with objects of this class.

## ◆ getClassStackIndex()

int SoMultiTextureMatrixElement::getClassStackIndex | ( | void |  | ) |
| static

This static method returns the state stack index for the class.

## ◆ createInstance()

void * SoMultiTextureMatrixElement::createInstance | ( | void |  | ) |
| static

This API member is considered internal to the library, as it is not likely to be of interest to the application programmer.
Creates a new instance of the class type corresponding to the SoType object.

## ◆ initClass()

void SoMultiTextureMatrixElement::initClass | ( | void |  | ) |
| static

Initialize relevant common data for all instances, like the type system.

## ◆ init()

void SoMultiTextureMatrixElement::init | ( | SoState * | state | ) |
| virtual

This function initializes the element type in the given SoState. It is called for the first element of each enabled element type in SoState objects.

Reimplemented from SoAccumulatedElement.

Reimplemented in SoGLMultiTextureMatrixElement.

## ◆ push()

void SoMultiTextureMatrixElement::push | ( | SoState * | state | ) |
| virtual

This method is called every time a new element is required in one of the stacks. This happens when a writable element is requested, using SoState::getElement() or indirectly SoElement::getElement(), and the depth of the current element is less than the state depth.

Override this method if your element needs to copy data from the previous top of stack. The push() method is called on the new element, and the previous element can be found using SoElement::getNextInStack().

Reimplemented from SoAccumulatedElement.

Reimplemented in SoGLMultiTextureMatrixElement.

## ◆ mult()

void SoMultiTextureMatrixElement::mult | ( | SoState *const | state,
|  | SoNode *const | node,
|  | const int | unit,
|  | const SbMatrix & | matrix )
| static

Multiplies matrix into the current texture matrix.

## ◆ get()

const SbMatrix & SoMultiTextureMatrixElement::get | ( | SoState *const | state,
|  | const int | unit = 0 )
| static

Returns current texture matrix.

## ◆ multElt()

void SoMultiTextureMatrixElement::multElt | ( | const int | unit,
|  | const SbMatrix & | matrix )
| protectedvirtual

virtual method which is called from mult(). Multiplies matrix into element matrix.

Reimplemented in SoGLMultiTextureMatrixElement.

## ◆ setElt()

void SoMultiTextureMatrixElement::setElt | ( | const int | unit,
|  | const SbMatrix & | matrix )
| protectedvirtual

virtual method which is called from set(). Sets matrix into element matrix.

Reimplemented in SoGLMultiTextureMatrixElement.

## ◆ getElt()

const SbMatrix & SoMultiTextureMatrixElement::getElt | ( | const int | unit | ) | const
| protectedvirtual

Returns element matrix. Called from get().

The documentation for this class was generated from the following files:

- SoMultiTextureMatrixElement.h
- SoMultiTextureMatrixElement.cpp